Subject: Re: bug#58247: Using guix time-machine results in unsupported manifest format error

From: david larsson <[email-masked]>
Date: Thu, 20 Oct 2022 20:44:23 +0200

On 2022-10-03 00:10, zimoun wrote:

[..]

> 
> Let try the converse,
> 
> --8<---------------cut here---------------start------------->8---
> $ guix time-machine --commit=729ce5f -- package -i hello -p /tmp/old
> 
> $ cat /tmp/old/manifest | grep -A 1 '(manifest'
> (manifest
>   (version 4)
> 
> $ guix package --list-generations -p /tmp/old
> Generation 1	oct. 02 2022 18:53:10
>   hello	2.10	out	/gnu/store/xg67cpxq2p6q7wn4y2z194pndwdymhpf-hello-2.10
> 
> Generation 2	oct. 02 2022 21:25:11	(current)
>  + 
> hello	2.12.1	out	/gnu/store/s5pd3rnzymliafb4la5sca63j86xs0y0-hello-2.12.1
>  - hello	2.10  
> 	out	/gnu/store/xg67cpxq2p6q7wn4y2z194pndwdymhpf-hello-2.10
> --8<---------------cut here---------------end--------------->8---
> 
> This profile /tmp/old is thus converted from version 3 to version 4, 
> and
> then, reusing old version of Guix fails,
> 
> --8<---------------cut here---------------start------------->8---
> $ guix time-machine --commit=7e8e070 -- package -i hello -p /tmp/old
> guix package: error: unsupported manifest format
> --8<---------------cut here---------------end--------------->8---
> 
> 
> Well, I do not know if a fix is possible.  The issue is a
> backward compatibility issue.
> 

Hi,
Thanks for the clarification.

I imagine it would be possible to give it a dirty fix, approximately as 
you just showed with /tmp/old, if you also just readd the default 
profile's currently installed packages to it at the end. So, if using 
~/.guix-profile, it would be something like:

1. Say your ~/.guix-profile is at commit=XYZ
2. build a NEW profile with the old package ONLY, from commit=ABC (as in 
/tmp/old)
3. guix pull /tmp/old "back" to commit=XYZ
4. install remaining packages that was in your ~/.guix-profile to 
/tmp/old.
5. mv the ~/.guix-profile symlink to /tmp/old.

( /tmp/old should just be in /var/guix/profiles/per-user/$USER as normal 
)

Building a new package generation like this would not be the same as 
usual, cuz the currently installed packages may come from different guix 
revisions. That might be a dealbreaker for fixing it. I do think it's 
very sad though, that the time-machine is kind of broken whenever the 
manifest gets a new version, with no hint even to the user how to find a 
solution.

Best regards,
David